const client = require('socket.io-client');
const fs = require('fs')

const API_URL = 'wss://api.developer.alt.ai/stt/stream'
const key = 'Your API Key';
const lang = 'ja-JP'
const filePath = 'audio file path'

const MIN_INTERVAL_MS = 200
const MAX_AUDIO_BUFFER_LEN = 32768

const socket = client.io(`${API_URL}?lang=${lang}&key=${key}`)
const list = []

socket.on("message", (msg) => {
  if (msg.status == 'RECOGNIZED') {
    console.log(`${msg.time}s: ${msg.content}`);
    list.push(msg.content)
  } else if (msg.status == 'CANCELED'){
    console.log('error');
    socket.disconnect();
  } else if (msg.status == 'SUCCEEDED') {
    console.log('result:', list.join('\n'));
    socket.disconnect();
  }
});

const init = async () => {
  try {
    console.log('start')
    await sleep(2000)
    socket.emit('start')
  
    const audioData = fs.readFileSync(filePath)
    for (let i = 0; i < audioData.length; i += MAX_AUDIO_BUFFER_LEN) {
      socket.emit('audioChunk', audioData.slice(i, i + MAX_AUDIO_BUFFER_LEN))
      await sleep(MIN_INTERVAL_MS)
    }
  
    socket.emit('end')
  } catch(e) {
    console.log(e)
  }
}

const sleep = (ms) => {
  return new Promise(resolve => {
    setTimeout(resolve, ms)
  })
}

init()